unit UnitAddRecordForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

const
  RECORD_TITLE_CANT_BE_BLANK = '       '
                                + '  .';

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Button1: TButton;
    procedure FormActivate(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure saveRecord;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses
  Unit1;

{$R *.dfm}

// -----------------------------------------------------------------------------

procedure TForm2.FormActivate(Sender: TObject);
begin
  edit1.SetFocus;
  edit1.SelectAll;
end;

// -----------------------------------------------------------------------------

//   Enter    ESC,    CRTL+A
procedure TForm2.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (ssCTRL in shift) AND (key = ord('A')) then begin
    edit1.SelectAll;
  end;

  if key = 27 then begin
    form2.Close;
  end;

  if key = 13 then begin
    saveRecord;
  end;
end;

// -----------------------------------------------------------------------------

procedure TForm2.saveRecord;
var
  recordTitle        : wideString;
  buffRecord         : TRecord;
  renamedRecordNumber: TRecordNumber;
begin
  recordTitle:=trim(edit1.Text);
  if recordTitle = '' then begin
    showError(RECORD_TITLE_CANT_BE_BLANK);
    edit1.SetFocus;
    exit;
  end;

  renamedRecordNumber:= form1.getRenamedRecordNumber;
  //     ?
    if renamedRecordNumber = -1 then begin
    //  
      buffRecord:=TRecord.create;
      buffRecord.setRecordTitle(recordTitle);
      form1.addToRecordsList(buffRecord);
      form1.ListBoxRecordsTitlesList.Items.Add(recordTitle);
      form1.ListBoxRecordsTitlesList.ItemIndex:=form1.GetRecordsNumber - 1;
      form1.BitBtnEraseCurrentRecord.Enabled:=true;
      form1.Memo1.Clear;
      form1.enableMemo;
      form1.LabelUsedCharactersNumber.Caption:=' : 0';
      form1.showRecord(form1.GetRecordsNumber - 1);
    end else begin
    // 
      form1.ListBoxRecordsTitlesList.Items[renamedRecordNumber]:=recordTitle;
      form1.getRecordByIndex(renamedRecordNumber).setRecordTitle(recordTitle);
      form1.Label1.Caption:=recordTitle;
    end;
  form1.Memo1.SetFocus;

  form1.saveRecordsToFile;
  form1.Button1.Enabled:=true;
  form2.Close;
end;

// -----------------------------------------------------------------------------

procedure TForm2.Button1Click(Sender: TObject);
begin
  saveRecord;
end;

end.
